// DI_API_TestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DI_API_Test.h"
#include "DI_API_TestDlg.h"
#include "..\..\..\Includes\ICPDAS_USBIO.h"
#include <SSTREAM>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

ICPDAS_USBIO USBIO;
BYTE m_byDITotal;
BYTE m_byDOTotal;
BYTE m_byAITotal;
BYTE m_byAOTotal;
BYTE m_byPITotal;
BYTE m_byPOTotal;

/////////////////////////////////////////////////////////////////////////////
// CDI_API_TestDlg dialog

CDI_API_TestDlg::CDI_API_TestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDI_API_TestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDI_API_TestDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDI_API_TestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDI_API_TestDlg)
	DDX_Control(pDX, IDC_TXTTIMEOUT, m_txtWDTTimeout);
	DDX_Control(pDX, IDC_TXTSETDIFILTERWIDTH, m_txtSetDIFilterWidth);
	DDX_Control(pDX, IDC_TXTNICKNAME, m_txtNickname);
	DDX_Control(pDX, IDC_TXTBOARDID, m_txtUserDefinedBID);
	DDX_Control(pDX, IDC_TXTBID, m_txtBID);
	DDX_Control(pDX, IDC_LBMODULEINFO, m_lbModuleInfo);
	DDX_Control(pDX, IDC_CBXDID, m_cbxDID);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDI_API_TestDlg, CDialog)
	//{{AFX_MSG_MAP(CDI_API_TestDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDOPEN, OnOpenDevice)
	ON_BN_CLICKED(IDCLOSE, OnCloseDevice)
	ON_BN_CLICKED(IDLOADDEFAULT, OnLoaddefault)
	ON_BN_CLICKED(IDREFRESHINFO, OnRefreshinfo)
	ON_BN_CLICKED(IDSETNICKNAME, OnSetnickname)
	ON_BN_CLICKED(IDSETWDTTIMEOUT, OnSetwdttimeout)
	ON_BN_CLICKED(IDSETBOARDID, OnSetboardid)
	ON_BN_CLICKED(IDGETDIFILTERWIDTH, OnGetdifilterwidth)
	ON_BN_CLICKED(IDGETDIVALINV, OnGetdivalinv)
	ON_BN_CLICKED(IDGETEDGETRIG, OnGetedgetrig)
	ON_BN_CLICKED(IDSETDIFILTERWIDTH, OnSetdifilterwidth)
	ON_BN_CLICKED(IDSETDIVALINV, OnSetdivalinv)
	ON_BN_CLICKED(IDSETCNTEDGETRIG, OnSetcntedgetrig)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDI_API_TestDlg message handlers

BOOL CDI_API_TestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
  SetIcon(m_hIcon, FALSE);		// Set small icon

  CButton* radio_Disable = (CButton*)GetDlgItem(IDC_RDBTNDIVALUEINVDISABLE);
  CButton* radio_Falling = (CButton*)GetDlgItem(IDC_RDBTNCNTEDGETRIGFALLING);

  m_txtBID.SetWindowText("1");
  m_cbxDID.SetCurSel(0);

  radio_Disable->SetCheck(true);
  radio_Falling->SetCheck(true);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDI_API_TestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDI_API_TestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDI_API_TestDlg::OnOpenDevice() 
{
  CString szBID;
  DWORD dwBID;
  int iSelIdx;
  int iErrCode;
  int iModuleID;
  
  m_txtBID.GetWindowText(szBID);
  dwBID = _tcstoul(szBID, NULL, 10);
  
  iSelIdx = m_cbxDID.GetCurSel();
  
  USBIO.SetCommTimeout(500);

  switch (iSelIdx)
  {
  case 0:
	  iModuleID = USB2026;
    break;
  case 1:
      iModuleID = USB2051;
    break;
  case 2:
      iModuleID = USB2055;
    break;
  case 3:
      iModuleID = USB2060;
    break;
  case 4:
	  iModuleID = USB2051_32;
	  break;
  case 5:
	  iModuleID = USB2055_32;
	  break;
  case 6:
	  iModuleID = USB2068_18;
    break;
  case 7:
	  iModuleID = USB2255_32;
    break;
  case 8:
	  iModuleID = USB2255_64;
    break;
  case 9:
	  iModuleID = USB2261_16;
	  break;
  case 10:
	  iModuleID = USB2261_32;
	  break;
  case 11:
	  iModuleID = USB2260_48;
	  break;
  case 12:
	  iModuleID = USB2260B_48;
	  break;
  case 13:
	  iModuleID = USB2260C_48;
	  break;
  case 14:
	  iModuleID = USB2260_24;
	  break;
  case 15:
	  iModuleID = USB2260B_24;
	  break;
  case 16:
	  iModuleID = USB2260C_24;
	  break;
  }
  printf("MID= 0x%x, BID=%d\r\n",iModuleID, (BYTE)dwBID);
  if(ERR_NO_ERR != (iErrCode = USBIO.OpenDevice(iModuleID, (BYTE)dwBID)))
  {
    char szMessage[10];
    sprintf(szMessage, "[%d]", iErrCode);
    
    MessageBox(szMessage, "Error", MB_ICONERROR | MB_OK);
  }
  else
  {
    char szItemString[200];
    DWORD dwSoftWDTTimeout;
    WORD wFWVer;
    BYTE byDeviceSN[USBIO_SN_LENGTH];
    BYTE byDeviceNickName[USBIO_NICKNAME_LENGTH];
    BYTE bySupIOMask;
    int iIdx;
    
    USBIO.GetSoftWDTTimeout(&dwSoftWDTTimeout);
    sprintf(szItemString, "SoftWDT: %d", dwSoftWDTTimeout);
    m_lbModuleInfo.AddString(szItemString);
    
    USBIO.GetFwVer(&wFWVer);
    sprintf(szItemString, "Version: %d", wFWVer);
    m_lbModuleInfo.AddString(szItemString);
    
    USBIO.GetDeviceNickName(byDeviceNickName);
    sprintf(szItemString, "Description: ");
    for(iIdx = 0; iIdx < USBIO_NICKNAME_LENGTH; iIdx++)
      sprintf(szItemString + strlen(szItemString), "%c", byDeviceNickName[iIdx]);
    m_lbModuleInfo.AddString(szItemString);
    
    USBIO.GetDeviceSN(byDeviceSN);
    sprintf(szItemString, "SN: ");
    for(iIdx = 0; iIdx < USBIO_SN_LENGTH; iIdx++)
      sprintf(szItemString + strlen(szItemString), "%C", byDeviceSN[iIdx]);
    m_lbModuleInfo.AddString(szItemString);
    
    USBIO.GetSupportIOMask(&bySupIOMask);
    sprintf(szItemString, "Support IO Mask: 0x%02X", bySupIOMask);
    m_lbModuleInfo.AddString(szItemString);
    
    if(SUPPORT_DI(bySupIOMask))
    {
      USBIO.GetDITotal(&m_byDITotal);
      sprintf(szItemString, "DI channels: %d", m_byDITotal);
      m_lbModuleInfo.AddString(szItemString);
    }
    
    if(SUPPORT_DO(bySupIOMask))
    {
      USBIO.GetDOTotal(&m_byDOTotal);
      sprintf(szItemString, "DO channels: %d", m_byDOTotal);
      m_lbModuleInfo.AddString(szItemString);
    }
    
    if(SUPPORT_AI(bySupIOMask))
    {
      USBIO.GetAITotal(&m_byAITotal);
      sprintf(szItemString, "AI channels: %d", m_byAITotal);
      m_lbModuleInfo.AddString(szItemString);
    }
    
    if(SUPPORT_AO(bySupIOMask))
    {
      USBIO.GetAOTotal(&m_byAOTotal);
      sprintf(szItemString, "AO channels: %d", m_byAOTotal);
      m_lbModuleInfo.AddString(szItemString);
    }
    
    if(SUPPORT_PI(bySupIOMask))
    {
      USBIO.GetPITotal(&m_byPITotal);
      sprintf(szItemString, "PI channels: %d", m_byPITotal);
      m_lbModuleInfo.AddString(szItemString);
    }
    
    if(SUPPORT_PO(bySupIOMask))
    {
      USBIO.GetPOTotal(&m_byPOTotal);
      sprintf(szItemString, "PO channels: %d", m_byPOTotal);
      m_lbModuleInfo.AddString(szItemString);
    }
  }
}

void CDI_API_TestDlg::OnCloseDevice() 
{
  int iErrCode;
  
  m_lbModuleInfo.ResetContent();
  
  if(ERR_NO_ERR != (iErrCode = USBIO.CloseDevice()))
  {
    char szMessage[10];
    sprintf(szMessage, "[%d]", iErrCode);
    
    MessageBox(szMessage, "Error", MB_ICONERROR | MB_OK);
  }
}

void CDI_API_TestDlg::OnLoaddefault() 
{
  int iErrCode;
  char szMessage[300];
  
  if(ERR_NO_ERR != (iErrCode = USBIO.LoadDefault()))
  {
    sprintf(szMessage, "[%d]", iErrCode);
    
    MessageBox(szMessage, "Error", MB_ICONERROR | MB_OK);
  }
}

void CDI_API_TestDlg::OnRefreshinfo() 
{
  int iErrCode;
  char szMessage[300];
  
  if(ERR_NO_ERR != (iErrCode = USBIO.RefreshDeviceInfo()))
  {
    sprintf(szMessage, "[%d]", iErrCode);
    
    MessageBox(szMessage, "Error", MB_ICONERROR | MB_OK);
  }
}

void CDI_API_TestDlg::OnSetnickname() 
{
  int iErrCode;
  char szMessage[300];
  BYTE byNickname[USBIO_NICKNAME_LENGTH];
  CString szNickname;
  
  m_txtNickname.GetWindowText(szNickname);
  memset(byNickname, 32, USBIO_NICKNAME_LENGTH);
  sscanf(szNickname, "%s", byNickname);
  
  if(ERR_NO_ERR != (iErrCode = USBIO.SetDeviceNickName(byNickname)))
  {
    sprintf(szMessage, "[%d]", iErrCode);
    
    MessageBox(szMessage, "Error", MB_ICONERROR | MB_OK);
  }
}

void CDI_API_TestDlg::OnSetwdttimeout() 
{
  int iErrCode;
  char szMessage[300];
  DWORD dwWDTTimeout;
  CString szWDTTimeout;
  
  m_txtWDTTimeout.GetWindowText(szWDTTimeout);
  dwWDTTimeout = _tcstoul(szWDTTimeout, NULL, 10);
  
  if(ERR_NO_ERR != (iErrCode = USBIO.SetSoftWDTTimeout(dwWDTTimeout)))
  {
    sprintf(szMessage, "[%d]", iErrCode);
    
    MessageBox(szMessage, "Error", MB_ICONERROR | MB_OK);
  }
}

void CDI_API_TestDlg::OnSetboardid() 
{
  int iErrCode;
  char szMessage[100];
  DWORD dwBoardID;
  CString szBoardID;
  
  m_txtUserDefinedBID.GetWindowText(szBoardID);
  dwBoardID = _tcstoul(szBoardID, NULL, 10);
  
  if(ERR_NO_ERR != (iErrCode = USBIO.SetUserDefinedBoardID(dwBoardID)))
  {
    sprintf(szMessage, "[%d]", iErrCode);
    
    MessageBox(szMessage, "Error", MB_ICONERROR | MB_OK);
  }
}

void CDI_API_TestDlg::OnGetdifilterwidth() 
{
  int iErrCode;
  WORD o_wFilterWidth;
  char szMessage[100];
  
  if(ERR_NO_ERR != (iErrCode = USBIO.DI_GetDigitalFilterWidth(&o_wFilterWidth)))
  {
    sprintf(szMessage, "[%d]", iErrCode);
    
    MessageBox(szMessage, "Error", MB_ICONERROR | MB_OK);
  }
  else
  {
    sprintf(szMessage, "Module digital filter width: %d * 100us", o_wFilterWidth);
    
    MessageBox(szMessage, "Information", MB_ICONINFORMATION | MB_OK);
  }
}

void CDI_API_TestDlg::OnGetdivalinv() 
{
  int iErrCode;
  DWORD o_dwInverse;
  char szMessage[100];
  
  if(ERR_NO_ERR != (iErrCode = USBIO.DI_GetDigitalValueInverse(&o_dwInverse)))
  {
    sprintf(szMessage, "[%d]", iErrCode);
    
    MessageBox(szMessage, "Error", MB_ICONERROR | MB_OK);
  }
  else
  {
    if(o_dwInverse == 0)
      sprintf(szMessage, "Module digital value inverse is disabled");
    else
      sprintf(szMessage, "Module digital value inverse is enabled");
    
    MessageBox(szMessage, "Information", MB_ICONINFORMATION | MB_OK);
  }
}

void CDI_API_TestDlg::OnGetedgetrig() 
{
  int iErrCode;
  DWORD o_dwEdgeTrig;
  char szMessage[100];
  
  if(ERR_NO_ERR != (iErrCode = USBIO.DI_GetCntEdgeTrigger(&o_dwEdgeTrig)))
  {
    sprintf(szMessage, "[%d]", iErrCode);
    
    MessageBox(szMessage, "Error", MB_ICONERROR | MB_OK);
  }
  else
  {
    if(o_dwEdgeTrig == 0)
      sprintf(szMessage, "Module counter edge trigger is falling");
    else
      sprintf(szMessage, "Module counter edge trigger is rising");
    
    MessageBox(szMessage, "Information", MB_ICONINFORMATION | MB_OK);
  }
}

void CDI_API_TestDlg::OnSetdifilterwidth() 
{
  int iErrCode;
  char szMessage[100];
  DWORD i_dwFilterWidth;
  CString szDIFilterWidth;
  
  m_txtSetDIFilterWidth.GetWindowText(szDIFilterWidth);
  i_dwFilterWidth = _tcstoul(szDIFilterWidth, NULL, 10);
  
  if(ERR_NO_ERR != (iErrCode = USBIO.DI_SetDigitalFilterWidth((WORD)i_dwFilterWidth)))
  {
    sprintf(szMessage, "[%d]", iErrCode);
    
    MessageBox(szMessage, "Error", MB_ICONERROR | MB_OK);
  }
  else
  {
    MessageBox("Success.", "Error", MB_ICONINFORMATION | MB_OK);
  }
}

void CDI_API_TestDlg::OnSetdivalinv() 
{
  int iErrCode;
  char szMessage[100];
  CButton* radio_Disable = (CButton*)GetDlgItem(IDC_RDBTNDIVALUEINVDISABLE);
  CButton* radio_Enable = (CButton*)GetDlgItem(IDC_RDBTNDIVALUEINVENABLE);
  DWORD i_dwInverse;

  if(radio_Disable->GetCheck())
    i_dwInverse = 0;
  if(radio_Enable->GetCheck())
    i_dwInverse = 1;
  
  if(ERR_NO_ERR != (iErrCode = USBIO.DI_SetDigitalValueInverse(i_dwInverse)))
  {
    sprintf(szMessage, "[%d]", iErrCode);
    
    MessageBox(szMessage, "Error", MB_ICONERROR | MB_OK);
  }
  else
  {
    MessageBox("Success.", "Error", MB_ICONINFORMATION | MB_OK);
  }
}

void CDI_API_TestDlg::OnSetcntedgetrig() 
{
  int iErrCode;
  char szMessage[100];
  CButton* radio_Falling = (CButton*)GetDlgItem(IDC_RDBTNCNTEDGETRIGFALLING);
  CButton* radio_Rising = (CButton*)GetDlgItem(IDC_RDBTNCNTEDGETRIGRISING);
  DWORD i_dwEdgeTrig;
  
  if(radio_Falling->GetCheck())
    i_dwEdgeTrig = 0;
  if(radio_Rising->GetCheck())
    i_dwEdgeTrig = 1;
  
  if(ERR_NO_ERR != (iErrCode = USBIO.DI_SetCntEdgeTrigger(i_dwEdgeTrig)))
  {
    sprintf(szMessage, "[%d]", iErrCode);
    
    MessageBox(szMessage, "Error", MB_ICONERROR | MB_OK);
  }
  else
  {
    MessageBox("Success.", "Error", MB_ICONINFORMATION | MB_OK);
  }
}
